char xcede2tobxh[29065] = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<xsl:stylesheet\n  xmlns=\"http://www.biac.duke.edu/bxh\"\n  xmlns:bxh=\"http://www.biac.duke.edu/bxh\"\n  xmlns:xcede2=\"http://www.xcede.org/xcede-2\"\n  xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\"\n  xmlns:exslt=\"http://exslt.org/common\"\n  xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n  exclude-result-prefixes=\"xcede2\"\n  version=\"1.0\">\n\n  <!-- This style sheet converts XCEDE 2 acquisition/data resource XML files to a BIAC XML Header -->\n\n  <xsl:output\n    method=\""
 "xml\"\n    indent=\"yes\"\n    omit-xml-declaration=\"no\"\n    />\n\n  <xsl:template name=\"convertNSattributes\">\n    <xsl:choose>\n      <xsl:when test=\"namespace-uri()=\'http://www.xcede.org/xcede-2\'\">\n        <xsl:attribute name=\"{local-name()}\" namespace=\"http://www.biac.duke.edu/bxh\">\n	  <xsl:copy/>\n        </xsl:attribute>\n      </xsl:when>\n      <xsl:otherwise>\n        <xsl:attribute name=\"{local-name()}\">\n          <xsl:copy/>\n        </xsl:attribute>\n      </xsl:otherwise>\n    </xsl:choose>\n  </xsl:template>\n "
 " <xsl:template name=\"convertNSaux\">\n    <xsl:choose>\n      <!-- element -->\n      <xsl:when test=\"self::*\">\n        <xsl:call-template name=\"convertNS\"/>\n      </xsl:when>\n      <!-- attribute -->\n      <xsl:when test=\"count(.|../@*)=count(../@*)\">\n        <xsl:call-template name=\"convertNSattributes\"/>\n      </xsl:when>\n      <!-- everything else -->\n      <xsl:otherwise>\n        <xsl:copy/>\n      </xsl:otherwise>\n    </xsl:choose>\n  </xsl:template>\n  <xsl:template name=\"convertNS\">\n    <xsl:choose>\n      "
 "<xsl:when test=\"namespace-uri()=\'http://www.xcede.org/xcede-2\'\">\n        <xsl:element name=\"{local-name()}\" namespace=\"http://www.biac.duke.edu/bxh\">\n          <xsl:for-each select=\"@*|*|text()\">\n            <xsl:call-template name=\"convertNSaux\"/>\n          </xsl:for-each>\n        </xsl:element>\n      </xsl:when>\n      <xsl:otherwise>\n        <xsl:copy>\n          <xsl:for-each select=\"@*|*|text()\">\n            <xsl:call-template name=\"convertNSaux\"/>\n          </xsl:for-each>\n        </xsl:copy>\n      </xs"
 "l:otherwise>\n    </xsl:choose>\n  </xsl:template>\n\n  <!-- return the composite ID for an XCEDE 2 hierarchy element (context).\n       Populate component IDs but stop at level \"stopLevel\". -->\n  <xsl:template name=\"getCompositeID\">\n    <xsl:param name=\"stopLevel\" />\n    <xsl:variable name=\"projectID\">\n      <xsl:choose>\n        <xsl:when test=\"local-name() = \'project\'\">\n          <xsl:value-of select=\"@ID\" />\n        </xsl:when>\n        <xsl:otherwise>\n          <xsl:value-of select=\"@projectID\" />\n        </x"
 "sl:otherwise>\n      </xsl:choose>\n    </xsl:variable>\n    <xsl:variable name=\"subjectID\">\n      <xsl:choose>\n        <xsl:when test=\"local-name() = \'subject\'\">\n          <xsl:value-of select=\"@ID\" />\n        </xsl:when>\n        <xsl:otherwise>\n          <xsl:value-of select=\"@subjectID\" />\n        </xsl:otherwise>\n      </xsl:choose>\n    </xsl:variable>\n    <xsl:variable name=\"visitID\">\n      <xsl:choose>\n        <xsl:when test=\"local-name() = \'visit\'\">\n          <xsl:value-of select=\"@ID\" />\n        </xsl:"
 "when>\n        <xsl:otherwise>\n          <xsl:value-of select=\"@visitID\" />\n        </xsl:otherwise>\n      </xsl:choose>\n    </xsl:variable>\n    <xsl:variable name=\"studyID\">\n      <xsl:choose>\n        <xsl:when test=\"local-name() = \'study\'\">\n          <xsl:value-of select=\"@ID\" />\n        </xsl:when>\n        <xsl:otherwise>\n          <xsl:value-of select=\"@studyID\" />\n        </xsl:otherwise>\n      </xsl:choose>\n    </xsl:variable>\n    <xsl:variable name=\"episodeID\">\n      <xsl:choose>\n        <xsl:when tes"
 "t=\"local-name() = \'episode\'\">\n          <xsl:value-of select=\"@ID\" />\n        </xsl:when>\n        <xsl:otherwise>\n          <xsl:value-of select=\"@episodeID\" />\n        </xsl:otherwise>\n      </xsl:choose>\n    </xsl:variable>\n    <xsl:variable name=\"acquisitionID\">\n      <xsl:choose>\n        <xsl:when test=\"local-name() = \'acquisition\'\">\n          <xsl:value-of select=\"@ID\" />\n        </xsl:when>\n        <xsl:otherwise>\n          <xsl:value-of select=\"@acquisitionID\" />\n        </xsl:otherwise>\n      </xsl:"
 "choose>\n    </xsl:variable>\n    <xsl:choose>\n      <xsl:when test=\"$stopLevel = \'project\'\">\n        <xsl:value-of select=\"concat($projectID,\':::::\')\" />\n      </xsl:when>\n      <xsl:when test=\"$stopLevel = \'subject\'\">\n        <xsl:value-of select=\"concat(\':\',$subjectID,\'::::\')\" />\n      </xsl:when>\n      <xsl:when test=\"$stopLevel = \'visit\'\">\n        <xsl:value-of select=\"concat($projectID,\':\',$subjectID,\':\',$visitID,\':::\')\" />\n      </xsl:when>\n      <xsl:when test=\"$stopLevel = \'study\'\">\n        <xsl:valu"
 "e-of select=\"concat($projectID,\':\',$subjectID,\':\',$visitID,\':\',$studyID,\'::\')\" />\n      </xsl:when>\n      <xsl:when test=\"$stopLevel = \'episode\'\">\n        <xsl:value-of select=\"concat($projectID,\':\',$subjectID,\':\',$visitID,\':\',$studyID,\':\',$episodeID,\':\')\" />\n      </xsl:when>\n      <xsl:when test=\"$stopLevel = \'acquisition\'\">\n        <xsl:value-of select=\"concat($projectID,\':\',$subjectID,\':\',$visitID,\':\',$studyID,\':\',$episodeID,\':\',$acquisitionID)\" />\n      </xsl:when>\n    </xsl:choose>\n  </xsl:template>\n\n"
 "  <!-- find elements of type \"type\" that match the IDs in the\n       context element, stopping at level \"stopLevel\"  -->\n  <xsl:template name=\"findElementsWithMatchingIDs\">\n    <xsl:param name=\"type\" />\n    <xsl:param name=\"stopLevel\" />\n    <xsl:variable name=\"levelNodes\">\n      <xsl:choose>\n        <xsl:when test=\"$type = \'project\'\">\n          <xsl:copy-of select=\"/xcede2:XCEDE/xcede2:project\" />\n        </xsl:when>\n        <xsl:when test=\"$type = \'subject\'\">\n          <xsl:copy-of select=\"/xcede2:XCEDE/x"
 "cede2:subject\" />\n        </xsl:when>\n        <xsl:when test=\"$type = \'visit\'\">\n          <xsl:copy-of select=\"/xcede2:XCEDE/xcede2:visit\" />\n        </xsl:when>\n        <xsl:when test=\"$type = \'study\'\">\n          <xsl:copy-of select=\"/xcede2:XCEDE/xcede2:study\" />\n        </xsl:when>\n        <xsl:when test=\"$type = \'episode\'\">\n          <xsl:copy-of select=\"/xcede2:XCEDE/xcede2:episode\" />\n        </xsl:when>\n        <xsl:when test=\"$type = \'acquisition\'\">\n          <xsl:copy-of select=\"/xcede2:XCEDE/xcede"
 "2:acquisition\" />\n        </xsl:when>\n        <xsl:when test=\"$type = \'data\'\">\n          <xsl:copy-of select=\"/xcede2:XCEDE/xcede2:data\" />\n        </xsl:when>\n      </xsl:choose>\n    </xsl:variable>\n    <xsl:variable name=\"contextCompositeID\">\n      <xsl:call-template name=\"getCompositeID\">\n        <xsl:with-param name=\"stopLevel\" select=\"$stopLevel\" />\n      </xsl:call-template>\n    </xsl:variable>\n    <xsl:for-each select=\"exslt:node-set($levelNodes)/*\">\n      <xsl:variable name=\"searchCompositeID\">\n    "
 "    <xsl:call-template name=\"getCompositeID\" />\n      </xsl:variable>\n      <xsl:if test=\"$contextCompositeID = $searchCompositeID\">\n        <xsl:copy-of select=\".\" />\n      </xsl:if>\n    </xsl:for-each>\n  </xsl:template>\n\n  <xsl:template match=\"/\">\n    <bxh>\n      <xsl:attribute name=\"version\">1.0</xsl:attribute>\n      <xsl:for-each select=\"xcede2:XCEDE\">\n        <xsl:for-each select=\"xcede2:resource\">\n          <xsl:variable name=\"resourceID\" select=\"@ID\" />\n          <xsl:call-template name=\"dodatarec\"/>"
 "\n          <xsl:for-each select=\"/xcede2:XCEDE/xcede2:acquisition[xcede2:dataResourceRef[@ID=$resourceID]]\">\n            <xsl:call-template name=\"doacquisitiondata\"/>\n            <xsl:variable name=\"subjectNode\">\n              <xsl:call-template name=\"findElementsWithMatchingIDs\">\n                <xsl:with-param name=\"type\" select=\"\'subject\'\" />\n                <xsl:with-param name=\"stopLevel\" select=\"\'subject\'\" />\n              </xsl:call-template>\n            </xsl:variable>\n            <xsl:variable name"
 "=\"dataNodes\">\n              <xsl:call-template name=\"findElementsWithMatchingIDs\">\n                <xsl:with-param name=\"type\" select=\"\'data\'\" />\n                <xsl:with-param name=\"stoplevel\" select=\"\'visit\'\" />\n              </xsl:call-template>\n            </xsl:variable>\n            <xsl:call-template name=\"dosubject\" select=\"exslt:node-set($subjectNodes)[1]\">\n              <xsl:with-param name=\"assessmentNodes\" select=\"exslt:node-set($dataNodes)/*[@xsi:type=\'assessment_t\']\" />\n            </xsl:call-"
 "template>\n          </xsl:for-each>\n        </xsl:for-each>\n      </xsl:for-each>\n    </bxh>\n  </xsl:template>\n\n  <!--\n       /bxh/datarec\n    -->\n  <xsl:template name=\"dodatarec\">\n    <xsl:call-template name=\"createdatarec\"/>\n  </xsl:template>\n\n  <xsl:template name=\"createdatarec\">\n    <datarec>\n      <xsl:attribute name=\"type\">\n        <xsl:value-of select=\"\'image\'\"/>\n      </xsl:attribute>\n      <xsl:if test=\"xcede2:originCoords\">\n        <xsl:element name=\"rasorigin\">\n          <xsl:value-of select=\"xce"
 "de2:originCoords\"/>\n        </xsl:element>\n      </xsl:if>\n\n      <xsl:for-each select=\"xcede2:dimension\">\n        <dimension>\n          <xsl:attribute name=\"type\">\n            <xsl:choose>\n              <xsl:when test=\"@splitRank\">\n                <xsl:value-of select=\"@label\"/>\n                <xsl:value-of select=\"\'-\'\"/>\n                <xsl:value-of select=\"@splitRank\"/>\n              </xsl:when>\n              <xsl:otherwise>\n                <xsl:value-of select=\"@label\"/>\n              </xsl:otherwise>"
 "\n            </xsl:choose>\n          </xsl:attribute>\n          <xsl:if test=\"@outputSelect\">\n            <xsl:attribute name=\"outputselect\">\n              <xsl:value-of select=\"@outputSelect\"/>\n            </xsl:attribute>\n          </xsl:if>\n	  <xsl:if test=\"xcede2:size\">\n            <size><xsl:value-of select=\"xcede2:size\"/></size>\n	  </xsl:if>\n	  <xsl:if test=\"xcede2:origin\">\n            <origin><xsl:value-of select=\"xcede2:origin\"/></origin>\n	  </xsl:if>\n	  <xsl:if test=\"xcede2:spacing\">\n            <s"
 "pacing><xsl:value-of select=\"xcede2:spacing\"/></spacing>\n	  </xsl:if>\n	  <xsl:if test=\"xcede2:gap\">\n            <gap><xsl:value-of select=\"xcede2:gap\"/></gap>\n	  </xsl:if>\n	  <xsl:for-each select=\"xcede2:datapoints\">\n	    <xsl:call-template name=\"convertNS\" select=\"xcede:datapoints\"/>\n	  </xsl:for-each>\n	  <xsl:if test=\"xcede2:direction\">\n            <direction><xsl:value-of select=\"xcede2:direction\"/></direction>\n	  </xsl:if>\n	  <xsl:if test=\"xcede2:units\">\n            <units><xsl:value-of select=\"xcede2:u"
 "nits\"/></units>\n	  </xsl:if>\n	  <xsl:if test=\"xcede2:measurementFrame\">\n            <measurementframe><xsl:value-of select=\"xcede2:measurementFrame\"/></measurementframe>\n	  </xsl:if>\n        </dimension>\n      </xsl:for-each>\n      <xsl:if test=\"xcede2:compression\">\n        <compression><xsl:value-of select=\"xcede2:compression\"/></compression>\n      </xsl:if>\n      <xsl:if test=\"xcede2:byteOrder\">\n        <byteorder><xsl:value-of select=\"xcede2:byteOrder\"/></byteorder>\n      </xsl:if>\n      <elementtype><xs"
 "l:value-of select=\"xcede2:elementType\"/></elementtype>\n      <xsl:for-each select=\"xcede2:uri\">\n        <filename><xsl:value-of select=\".\"/></filename>\n        <xsl:if test=\"@offset\">\n          <fileoffset>\n            <xsl:value-of select=\"@offset\"/>\n          </fileoffset>\n        </xsl:if>\n        <xsl:if test=\"size\">\n          <filerecordsize>\n            <xsl:value-of select=\"@size\"/>\n          </filerecordsize>\n        </xsl:if>\n      </xsl:for-each>\n    </datarec>\n  </xsl:template>\n\n  <!--\n      /bxh"
 "/subject\n    -->\n  <xsl:template name=\"dosubject\">\n    <xsl:param name=\"assessmentNodes\" />\n    <subject>\n      <xsl:for-each select=\"$assessmentNodes[xcede2:name=\'age\']\">\n        <age>\n          <xsl:value-of select=\"xcede2:dataInstance/xcede2:assessmentItem/xcede2:value\"/>\n        </age>\n      </xsl:for-each>\n      <xsl:for-each select=\"xcede2:subjectInfo\">\n        <sex>\n          <xsl:choose>\n            <xsl:when test=\"xcede2:sex = \'male\'\">M</xsl:when>\n            <xsl:when test=\"xcede2:sex = \'female\'\">"
 "F</xsl:when>\n            <xsl:otherwise>O</xsl:otherwise>\n          </xsl:choose>\n        </sex>\n      </xsl:for-each>\n    </subject>\n  </xsl:template>\n\n  <!--\n      /bxh/acquisitiondata\n    -->\n  <xsl:template name=\"doacquisitiondata\">\n    <xsl:for-each select=\"xcede2:acquisitionInfo\">\n      <acquisitiondata>\n        <xsl:if test=\"xcede2:description\">\n          <description>\n            <xsl:value-of select=\"xcede2:description\" />\n          </description>\n        </xsl:if>\n        <xsl:for-each select=\"xce"
 "de2:scanner\">\n          <xsl:for-each select=\"xcede2:manufacturer\">\n            <scannermanufacturer><xsl:value-of select=\".\" /></scannermanufacturer>\n          </xsl:for-each>\n          <xsl:for-each select=\"xcede2:institutionName\">\n            <institution><xsl:value-of select=\".\" /></institution>\n          </xsl:for-each>\n          <xsl:for-each select=\"xcede2:institutionAddress\">\n            <institutionaddress><xsl:value-of select=\".\" /></institutionaddress>\n          </xsl:for-each>\n          <xsl:for"
 "-each select=\"xcede2:stationName\">\n            <scanner><xsl:value-of select=\".\" /></scanner>\n          </xsl:for-each>\n          <xsl:for-each select=\"xcede2:institutionalDepartmentName\">\n            <institutionaldepartmentname><xsl:value-of select=\".\" /></institutionaldepartmentname>\n          </xsl:for-each>\n          <xsl:for-each select=\"xcede2:modelName\">\n            <scannermodelname><xsl:value-of select=\".\" /></scannermodelname>\n          </xsl:for-each>\n          <xsl:for-each select=\"xcede2:seria"
 "lNumber\">\n            <scannerSerialNumber><xsl:value-of select=\".\" /></scannerSerialNumber>\n          </xsl:for-each>\n          <xsl:for-each select=\"xcede2:softwareVersions\">\n            <softwareversions><xsl:value-of select=\".\" /></softwareversions>\n          </xsl:for-each>\n          <xsl:for-each select=\"xcede2:spatialResolution\">\n            <spatialresolution><xsl:value-of select=\".\" /></spatialresolution>\n          </xsl:for-each>\n          <xsl:for-each select=\"xcede2:dateLastCalibration\">\n       "
 "     <datelastcalibration><xsl:value-of select=\".\" /></datelastcalibration>\n          </xsl:for-each>\n          <xsl:for-each select=\"xcede2:timeLastCalibration\">\n            <timelastcalibration><xsl:value-of select=\".\" /></timelastcalibration>\n          </xsl:for-each>\n          <xsl:for-each select=\"xcede2:pixelPaddingValue\">\n            <pixelpaddingvalue><xsl:value-of select=\".\" /></pixelpaddingvalue>\n          </xsl:for-each>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:rows\">\n        "
 "  <rows><xsl:value-of select=\".\" /></rows>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:columns\">\n          <columns><xsl:value-of select=\".\" /></columns>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:sliceThickness\">\n          <slicethickness><xsl:value-of select=\".\" /></slicethickness>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:protocolName\">\n          <protocolname><xsl:value-of select=\".\" /></protocolname>\n        </xsl:for-each>\n        <xsl:for-each sel"
 "ect=\"xcede2:scanningSequence\">\n          <scanningsequence><xsl:value-of select=\".\" /></scanningsequence>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:sequenceVariant\">\n          <sequencevariant><xsl:value-of select=\".\" /></sequencevariant>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:scanOptions\">\n          <scanoptions><xsl:value-of select=\".\" /></scanoptions>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:acquisitionType\">\n          <mracquisitiontype><xsl:v"
 "alue-of select=\".\" /></mracquisitiontype>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:tr\">\n          <tr><xsl:value-of select=\".\" /></tr>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:te\">\n          <te><xsl:value-of select=\".\" /></te>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:echoTrainLength\">\n          <echotrainlength><xsl:value-of select=\".\" /></echotrainlength>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:ti\">\n          <ti><xsl:value-o"
 "f select=\".\" /></ti>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:triggerTime\">\n          <triggertime><xsl:value-of select=\".\" /></triggertime>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:sequenceName\">\n          <sequencename><xsl:value-of select=\".\" /></sequencename>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:angioFlag\">\n          <angioflag><xsl:value-of select=\".\" /></angioflag>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:numAverages\">"
 "\n          <numaverages><xsl:value-of select=\".\" /></numaverages>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:imagingFrequency\">\n          <frequency><xsl:value-of select=\".\" /></frequency>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:imagedNucleus\">\n          <imagednucleus><xsl:value-of select=\".\" /></imagednucleus>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:echoNumber\">\n          <echonum><xsl:value-of select=\".\" /></echonum>\n        </xsl:for-each>\n    "
 "    <xsl:for-each select=\"xcede2:magneticField\">\n          <fieldstrength><xsl:value-of select=\".\" /></fieldstrength>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:numPhaseEncodingSteps\">\n          <numphaseencodingsteps><xsl:value-of select=\".\" /></numphaseencodingsteps>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:percentSampling\">\n          <percentsampling><xsl:value-of select=\".\" /></percentsampling>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:percentPhas"
 "eFieldOfView\">\n          <percentphasefov><xsl:value-of select=\".\" /></percentphasefov>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:pixelBandwidth\">\n          <pixelbandwidth><xsl:value-of select=\".\" /></pixelbandwidth>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:nominalInterval\">\n          <nominalinterval><xsl:value-of select=\".\" /></nominalinterval>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:beatRejectionFlag\">\n          <beatrejectionflag><xsl:value-of"
 " select=\".\" /></beatrejectionflag>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:lowRRValue\">\n          <lowrrvalue><xsl:value-of select=\".\" /></lowrrvalue>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:highRRValue\">\n          <highrrvalue><xsl:value-of select=\".\" /></highrrvalue>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:intervalsAcquired\">\n          <intervalsacquired><xsl:value-of select=\".\" /></intervalsacquired>\n        </xsl:for-each>\n        <xsl:for-e"
 "ach select=\"xcede2:intervalsRejected\">\n          <intervalsrejected><xsl:value-of select=\".\" /></intervalsrejected>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:pvcRejection\">\n          <pvcrejection><xsl:value-of select=\".\" /></pvcrejection>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:skipBeats\">\n          <skipbeats><xsl:value-of select=\".\" /></skipbeats>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:heartRate\">\n          <heartrate><xsl:value-of select=\".\" "
 "/></heartrate>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:cardiacNumberOfImages\">\n          <cardiacnumimages><xsl:value-of select=\".\" /></cardiacnumimages>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:triggerWindow\">\n          <triggerwindow><xsl:value-of select=\".\" /></triggerwindow>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:reconstructionDiameter\">\n          <reconstructiondiameter><xsl:value-of select=\".\" /></reconstructiondiameter>\n        </xsl:for-"
 "each>\n        <xsl:for-each select=\"xcede2:receiveCoilName\">\n          <receivecoilname><xsl:value-of select=\".\" /></receivecoilname>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:transmitCoilName\">\n          <transmitcoilname><xsl:value-of select=\".\" /></transmitcoilname>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:acquisitionMatrix\">\n          <acquisitionmatrix><xsl:value-of select=\".\" /></acquisitionmatrix>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:phas"
 "eEncodingDirection\">\n          <phaseencodingdirection><xsl:value-of select=\".\" /></phaseencodingdirection>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:flipAngle\">\n          <flipangle><xsl:value-of select=\".\" /></flipangle>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:SAR\">\n          <sar><xsl:value-of select=\".\" /></sar>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:variableFlipAngleFlag\">\n          <variableflipangleflag><xsl:value-of select=\".\" /></variabl"
 "eflipangleflag>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:dBdt\">\n          <dbdt><xsl:value-of select=\".\" /></dbdt>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:temporalPositionIdentifier\">\n          <temporalpositionidentifier><xsl:value-of select=\".\" /></temporalpositionidentifier>\n        </xsl:for-each>\n        <xsl:for-each select=\"xcede2:numTemporalPositions\">\n          <numtemporalpositions><xsl:value-of select=\".\" /></numtemporalpositions>\n        </xsl:for-each>\n "
 "       <xsl:for-each select=\"xcede2:temporalResolution\">\n          <temporalresolution><xsl:value-of select=\".\" /></temporalresolution>\n        </xsl:for-each>\n\n        <xsl:for-each select=\"xcede2:param\">\n          <xsl:choose>\n            <xsl:when test=\"@name = \'examnumber\'\">\n              <examnumber><xsl:value-of select=\".\"/></examnumber>\n            </xsl:when>\n            <xsl:when test=\"@name = \'studyid\'\">\n              <studyid><xsl:value-of select=\".\"/></studyid>\n            </xsl:when>\n          "
 "  <xsl:when test=\"@name = \'seriesnumber\'\">\n              <seriesnumber><xsl:value-of select=\".\"/></seriesnumber>\n            </xsl:when>\n            <xsl:when test=\"@name = \'runnumber\'\">\n              <runnumber><xsl:value-of select=\".\"/></runnumber>\n            </xsl:when>\n            <xsl:when test=\"@name = \'scanningsequence\'\">\n              <scanningsequence><xsl:value-of select=\".\"/></scanningsequence>\n            </xsl:when>\n            <xsl:when test=\"@name = \'sequencevariant\'\">\n              <sequenc"
 "evariant><xsl:value-of select=\".\"/></sequencevariant>\n            </xsl:when>\n            <xsl:when test=\"@name = \'magneticfield\'\">\n              <magneticfield><xsl:value-of select=\".\"/></magneticfield>\n            </xsl:when>\n            <xsl:when test=\"@name = \'description\'\">\n              <description><xsl:value-of select=\".\"/></description>\n            </xsl:when>\n            <xsl:when test=\"@name = \'scandate\'\">\n              <scandate><xsl:value-of select=\".\"/></scandate>\n            </xsl:when>\n     "
 "       <xsl:when test=\"@name = \'scantime\'\">\n              <scantime><xsl:value-of select=\".\"/></scantime>\n            </xsl:when>\n            <xsl:when test=\"@name = \'tr\'\">\n              <tr><xsl:value-of select=\".\"/></tr>\n            </xsl:when>\n            <xsl:when test=\"@name = \'te\'\">\n              <te><xsl:value-of select=\".\"/></te>\n            </xsl:when>\n            <xsl:when test=\"@name = \'echospacing\'\">\n              <echospacing><xsl:value-of select=\".\"/></echospacing>\n            </xsl:when>\n    "
 "        <xsl:when test=\"@name = \'nechos\'\">\n              <nechos><xsl:value-of select=\".\"/></nechos>\n            </xsl:when>\n            <xsl:when test=\"@name = \'echonumber\'\">\n              <echonumber><xsl:value-of select=\".\"/></echonumber>\n            </xsl:when>\n            <xsl:when test=\"@name = \'nshots\'\">\n              <nshots><xsl:value-of select=\".\"/></nshots>\n            </xsl:when>\n            <xsl:when test=\"@name = \'sensefactor\'\">\n              <sensefactor><xsl:value-of select=\".\"/></sensefacto"
 "r>\n            </xsl:when>\n            <xsl:when test=\"@name = \'operator\'\">\n              <operator><xsl:value-of select=\".\"/></operator>\n            </xsl:when>\n            <xsl:when test=\"@name = \'flipangle\'\">\n              <flipangle><xsl:value-of select=\".\"/></flipangle>\n            </xsl:when>\n            <xsl:when test=\"@name = \'prescribedslicespacing\'\">\n              <prescribedslicespacing><xsl:value-of select=\".\"/></prescribedslicespacing>\n            </xsl:when>\n            <xsl:when test=\"@name ="
 " \'frequencydirection\'\">\n              <frequencydirection><xsl:value-of select=\".\"/></frequencydirection>\n              <xsl:if test=\"not(../xcede2:phaseEncodingDirection)\">\n                <xsl:choose>\n                  <xsl:when test=\". = 1\">\n                    <phaseencodingdirection>COL</phaseencodingdirection>\n                  </xsl:when>\n                  <xsl:when test=\". = 2\">\n                    <phaseencodingdirection>ROW</phaseencodingdirection>\n                  </xsl:when>\n                </x"
 "sl:choose>\n              </xsl:if>\n            </xsl:when>\n            <xsl:when test=\"@name = \'acquisitionmatrix\'\">\n              <acquisitionmatrix><xsl:value-of select=\".\"/></acquisitionmatrix>\n            </xsl:when>\n            <xsl:when test=\"@name = \'bandwidth\'\">\n              <bandwidth><xsl:value-of select=\".\"/></bandwidth>\n            </xsl:when>\n            <xsl:when test=\"@name = \'pixelbandwidth\'\">\n              <pixelbandwidth><xsl:value-of select=\".\"/></pixelbandwidth>\n            </xsl:when>\n"
 "            <xsl:when test=\"@name = \'receivecoilname\'\">\n              <receivecoilname><xsl:value-of select=\".\"/></receivecoilname>\n            </xsl:when>\n            <xsl:when test=\"@name = \'transmitcoilname\'\">\n              <transmitcoilname><xsl:value-of select=\".\"/></transmitcoilname>\n            </xsl:when>\n            <xsl:when test=\"@name = \'institution\'\">\n              <institution><xsl:value-of select=\".\"/></institution>\n            </xsl:when>\n            <xsl:when test=\"@name = \'institutionaddre"
 "ss\'\">\n              <institutionaddress><xsl:value-of select=\".\"/></institutionaddress>\n            </xsl:when>\n            <xsl:when test=\"@name = \'institutionaldepartmentname\'\">\n              <institutionaldepartmentname><xsl:value-of select=\".\"/></institutionaldepartmentname>\n            </xsl:when>\n            <xsl:when test=\"@name = \'examdescription\'\">\n              <examdescription><xsl:value-of select=\".\"/></examdescription>\n            </xsl:when>\n            <xsl:when test=\"@name = \'scanner\'\">\n    "
 "          <scanner><xsl:value-of select=\".\"/></scanner>\n            </xsl:when>\n            <xsl:when test=\"@name = \'scannermanufacturer\'\">\n              <scannermanufacturer><xsl:value-of select=\".\"/></scannermanufacturer>\n            </xsl:when>\n            <xsl:when test=\"@name = \'scannermodelname\'\">\n              <scannermodelname><xsl:value-of select=\".\"/></scannermodelname>\n            </xsl:when>\n            <xsl:when test=\"@name = \'fieldofview\'\">\n              <fieldofview><xsl:value-of select=\".\"/>"
 "</fieldofview>\n            </xsl:when>\n            <xsl:when test=\"@name = \'ti\'\">\n              <ti><xsl:value-of select=\".\"/></ti>\n            </xsl:when>\n            <xsl:when test=\"@name = \'psdname\'\">\n              <psdname><xsl:value-of select=\".\"/></psdname>\n            </xsl:when>\n            <xsl:when test=\"@name = \'psdinternalname\'\">\n              <psdinternalname><xsl:value-of select=\".\"/></psdinternalname>\n            </xsl:when>\n            <xsl:when test=\"@name = \'psddate\'\">\n              <psdda"
 "te><xsl:value-of select=\".\"/></psddate>\n            </xsl:when>\n            <xsl:when test=\"@name = \'psdtime\'\">\n              <psdtime><xsl:value-of select=\".\"/></psdtime>\n            </xsl:when>\n            <xsl:when test=\"@name = \'protocolname\'\">\n              <protocolname><xsl:value-of select=\".\"/></protocolname>\n            </xsl:when>\n            <xsl:when test=\"@name = \'sliceorder\'\">\n              <sliceorder><xsl:value-of select=\".\"/></sliceorder>\n            </xsl:when>\n            <xsl:when test=\""
 "@name = \'bvalues\'\">\n              <bvalues><xsl:value-of select=\".\"/></bvalues>\n            </xsl:when>\n            <xsl:otherwise>\n              <xsl:element name=\"acqParam\">\n                <xsl:for-each select=\"@*|node()\">\n                  <xsl:copy-of select=\".\">\n                  </xsl:copy-of>\n                </xsl:for-each>\n              </xsl:element>\n            </xsl:otherwise>\n          </xsl:choose>\n        </xsl:for-each>\n      </acquisitiondata>\n    </xsl:for-each>\n    <history>\n      <xsl:fo"
 "r-each select=\"xcede2:provenance/xcede2:processStep\">\n        <entry>\n          <date><xsl:value-of select=\"xcede2:timeStamp\"/></date>\n          <description>\n            <xsl:copy-of select=\".\" />\n          </description>\n        </entry>\n      </xsl:for-each>\n    </history>\n  </xsl:template>\n\n</xsl:stylesheet>\n\n\n<!--\n  $Log: In-line log eliminated on transition to SVN; use svn log instead. $\n  Revision 1.1  2008/03/07 18:21:59  gadde\n  Add preliminary XCEDE 2 support\n\n  Revision 1.9  2007/02/27 18:04:38  "
 "gadde\n  Add more acquisition data parameters.\n\n  Revision 1.8  2007/02/21 21:49:15  gadde\n  Make sure all acquisitiondata and acqParam elements are translated BXH->XCEDE and vice-versa\n\n  Revision 1.7  2007/02/01 15:39:22  gadde\n  Add compression field\n\n  Revision 1.6  2006/02/09 21:40:36  gadde\n  Write bxh rasorigin field.\n\n  Revision 1.5  2006/01/03 17:14:33  gadde\n  Add CVS log.\n\n  -->\n";
